# Build configuration

# set to 1 to enable bootstrap
%define bootstrap  1

%define with_clang 1

%if ! 0%{?bootstrap}
%define build_docs 0
%else
%define build_docs 0
%endif
%ifarch %{arm} aarch64 %{ix86}
%define build_docs 0
%endif

# Versioning

%define qtmajor 6
%define qtminor 3
%define qtsubminor 1
%define qtversion %{qtmajor}.%{qtminor}.%{qtsubminor}

%define rel 1

%define snapshot 0

%if 0%{?snapshot}
%define pre rc
%endif

%define qttarballdir qttools-everywhere-src-%{qtversion}%{?pre:-%{pre}}

# Library names

%define libqthelp       %mklibname qt%{qtmajor}help %{qtmajor}
%define libqthelp_d     %mklibname qt%{qtmajor}help -d

%define libqtdesigner   %mklibname qt%{qtmajor}designer %{qtmajor}
%define libqtdesigner_d %mklibname qt%{qtmajor}designer -d

%define libqtuitools    %mklibname qt%{qtmajor}uitools %{qtmajor}
%define libqtuitools_d  %mklibname qt%{qtmajor}uitools -d

%define libqttools_d    %mklibname qt%{qtmajor}tools -d

Name:           qttools6
Version:        %{qtversion}
Release:        %mkrel %{rel}
Summary:        Qt%{qtmajor} GUI toolkit
Group:          Development/KDE and Qt
License:        LGPLv2 with exceptions or GPLv3 with exceptions and GFDL
URL:            https://www.qt.io/
Source0:        https://download.qt.io/official_releases/qt/%{qtmajor}.%{qtminor}/%{version}/submodules/%{qttarballdir}.tar.xz
Source1:        mageia-assistant-qt6.desktop
Source2:        mageia-designer-qt6.desktop
Source3:        mageia-linguist-qt6.desktop

# Patch from Mageia

BuildRequires:  cmake
BuildRequires:  ninja
BuildRequires:  qtbase6-devel
BuildRequires:  qtbase6-qtpaths

%if ! 0%{?bootstrap}
BuildRequires:  cmake(Qt6Qml)
BuildRequires:  cmake(Qt6Quick)
BuildRequires:  cmake(Qt6QuickWidgets)
BuildRequires:  cmake(litehtml)
BuildRequires:  cmake(Qt6Help)
%endif
%if %with_clang
BuildRequires:  clang-devel
%endif
BuildRequires:  llvm-devel

BuildRequires:  sed

%if ! 0%{?bootstrap}
Requires:       qttranslations6
%endif
Requires:       qttools6-assistant
Requires:       qtbase6-qtpaths

Provides:       qt%{qtmajor}-qttools = %{version}-%{release}

%description
Qt%{qtmajor} GUI tools.

%files
%{_qt6_bindir}/lconvert*
%{_bindir}/lconvert*
%{_qt6_bindir}/linguist*
%{_bindir}/linguist*
%{_qt6_bindir}/lrelease*
%{_bindir}/lrelease*
%{_qt6_bindir}/lupdate*
%{_bindir}/lupdate*
%{_qt6_bindir}/pixeltool*
%{_bindir}/pixeltool*
%{_qt6_bindir}/qtdiag*
%{_bindir}/qtdiag*
%{_qt6_bindir}/qtplugininfo**
%{_bindir}/qtplugininfo*
%if %with_clang
%{_qt6_bindir}/qdoc*
%{_bindir}/qdoc*
%endif
%{_qt6_datadir}/phrasebooks
%{_datadir}/applications/*linguist*.desktop
%{_qt6_libdir}/lprodump*
%{_qt6_libdir}/lrelease*
%{_qt6_libdir}/lupdate*
%{_qt6_libdir}/qtattributionsscanner
%if ! 0%{?bootstrap}
%{_qt6_bindir}/qdistancefieldgenerator*
%{_bindir}/qdistancefieldgenerator-qt6
%endif

#------------------------------------------------------------------------------

%package assistant
Summary:        Qt%{qtmajor} Assistant Doc Utility
Group:          Documentation
Requires:       qtbase6-database-plugin-sqlite
%if ! 0%{?bootstrap}
Requires:       qttranslations6
%endif

%description assistant
Qt%{qtmajor} Assistant provides a documentation Browser.

%files assistant
%{_qt6_bindir}/assistant*
%{_bindir}/assistant*
%{_datadir}/applications/*assistant*.desktop
#FIXME: in the good package ?
%{_qt6_libdir}/qhelpgen*
%if ! 0%{?bootstrap}
%{_qt6_examplesdir}/assistant/
%{_bindir}/qhelpgen*
%endif

#------------------------------------------------------------------------------

%package designer
Summary:        %{name} Visual Design Tool
Group:          Development/KDE and Qt
Requires:       qttranslations6

%description designer
The Qt Designer is a visual design tool that makes designing and
implementing user interfaces a lot easier.

%files designer
%{_qt6_bindir}/design*
%{_bindir}/design*
%if ! 0%{?bootstrap}
%{_qt6_plugindir}/designer/libqquickwidget.so
%endif
%{_datadir}/applications/*designer*.desktop

#------------------------------------------------------------------------------

%package qtdbus
Summary:        Qt%{qtmajor} Dbus Binary
Group:          Development/KDE and Qt
Requires:       qttools6-qtpaths

%description qtdbus
Qt%{qtmajor} Dbus Binary.

The QtDBus module is a Unix-only library that you can use to perform
Inter-Process Communication using the D-Bus protocol.

%files qtdbus
%{_bindir}/qdbus-qt6
%{_qt6_bindir}/qdbus
%{_qt6_bindir}/qdbus-qt6
%{_qt6_bindir}/qdbusviewer*
%{_bindir}/qdbusviewer*

#------------------------------------------------------------------------------

%if %{build_docs}
%package doc
Summary:        QtTools%{qtmajor} APIs and tools docs
Group:          Documentation
BuildArch:      noarch
BuildRequires:  qttools6
# This one is required to build QCH-format documentation
# for APIs and tools in this package set
BuildRequires:  %{name}-assistant
Recommends:     %{name}-assistant

%description doc
Documentation for APIs and tools in QtTools%{qtmajor} package for use with
Qt Assistant.

%files doc
%{_qt6_docdir}/qtassistant.qch
%{_qt6_docdir}/qtassistant/
%{_qt6_docdir}/qtdesigner.qch
%{_qt6_docdir}/qtdesigner/
%if %with_clang
%{_qt6_docdir}/qdoc.qch
%{_qt6_docdir}/qdoc/
%endif
%{_qt6_docdir}/qthelp.qch
%{_qt6_docdir}/qthelp/
%{_qt6_docdir}/qtlinguist.qch
%{_qt6_docdir}/qtlinguist/
%{_qt6_docdir}/qtuitools.qch
%{_qt6_docdir}/qtuitools/
%endif

#------------------------------------------------------------------------------

%package -n %{libqthelp}
Summary:        Qt%{qtmajor} Help Library
Group:          System/Libraries
Provides:       qt6helplib = %{version}

%description -n %{libqthelp}
Qt%{qtmajor} Help Component Library.

The QtHelp module provides classes for integrating online documentation
in applications.

%files -n %{libqthelp}
%{_qt6_libdir}/libQt6Help.so.%{qtmajor}{,.*}

#------------------------------------------------------------------------------

%package -n %{libqthelp_d}
Summary:        Devel files needed to build apps based on QtHelp and QtLinguistTools
Group:          Development/KDE and Qt
Requires:       %{libqthelp} = %{version}
Requires:       qtbase6-common-devel = %{version}
Requires:       qttools6
Provides:       libqthelp6-devel = %{version}
Provides:       libqt6help-devel = %{version}
Provides:       qthelp6-devel = %{version}
Provides:       qt6help-devel = %{version}
Provides:       qtlinguisttools6-devel = %{version}
Provides:       qt6linguisttools-devel = %{version}
Provides:       qtdoctools6-devel = %{version}
Provides:       qt6doctools-devel = %{version}

Provides:       libqthelp6-private-devel = %{version}
Provides:       libqt6help-private-devel = %{version}
Provides:       qthelp6-private-devel = %{version}
Provides:       qt6help-private-devel = %{version}

%description -n %{libqthelp_d}
Devel files needed to build apps based on QtHelp and QtLinguistTools.

%files -n %{libqthelp_d}
%{_qt6_libdir}/libQt6Help.prl
%{_qt6_libdir}/libQt6Help.so
%{_qt6_includedir}/QtHelp/
%{_qt6_libdir}/cmake/Qt6Help/
#FIXME: Find a better place
%{_qt6_libdir}/cmake/Qt6Linguist/
%{_qt6_libdir}/cmake/Qt6LinguistTools/
%if %with_clang
%{_qt6_libdir}/cmake/Qt6/FindWrapLibClang.cmake
%endif
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_help.pri
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_help_private.pri
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_linguist.pri
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_linguist_private.pri
%{_qt6_datadir}/modules/Help.json
%{_qt6_datadir}/modules/Linguist.json
%{_qt6_libdir}/metatypes/qt6help_relwithdebinfo_metatypes.json
%if ! 0%{?bootstrap}
%{_qt6_examplesdir}/help/
%{_qt6_examplesdir}/linguist/
%endif

#------------------------------------------------------------------------------

%package -n %{libqtdesigner}
Summary:        Qt%{qtmajor} Designer Library
Group:          System/Libraries
Provides:       qt6designerlib = %{version}

%description -n %{libqtdesigner}
Qt%{qtmajor} Designer Component Library.

The QtDesigner module provides classes that allow you to create your own
custom widget plugins for Qt Designer, and classes that enable you to
access Qt Designer's components.

%files -n %{libqtdesigner}
%{_qt6_libdir}/libQt6Designer.so.%{qtmajor}{,.*}
%{_qt6_libdir}/libQt6DesignerComponents.so.%{qtmajor}{,.*}

#------------------------------------------------------------------------------

%package -n %{libqtdesigner_d}
Summary:        Devel files needed to build apps based on QtDesigner
Group:          Development/KDE and Qt
Requires:       %{libqtdesigner} = %{version}
Requires:       qttools6-designer = %{version}
Provides:       libqtdesigner6-devel = %{version}
Provides:       libqt6designer-devel = %{version}
Provides:       qtdesigner6-devel = %{version}
Provides:       qt6designer-devel = %{version}

Provides:       libqtdesigner6-private-devel = %{version}
Provides:       libqt6designer-private-devel = %{version}
Provides:       qtdesigner6-private-devel = %{version}
Provides:       qt6designer-private-devel = %{version}

%description -n %{libqtdesigner_d}
Devel files needed to build apps based on QtDesigner.

%files -n %{libqtdesigner_d}
%{_qt6_libdir}/libQt6Designer.so
%{_qt6_libdir}/libQt6DesignerComponents.so
%{_qt6_libdir}/libQt6Designer.prl
%{_qt6_libdir}/libQt6DesignerComponents.prl
%{_qt6_includedir}/QtDesignerComponents/
%{_qt6_includedir}/QtDesigner/
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_designer.pri
%{_qt6_libdir}/cmake/Qt6Designer/
%{_qt6_libdir}/cmake/Qt6DesignerComponentsPrivate/
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_designer_private.pri
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_designercomponents_private.pri
%{_qt6_datadir}/modules/Designer.json
%{_qt6_datadir}/modules/DesignerComponentsPrivate.json
%if ! 0%{?bootstrap}
%{_qt6_examplesdir}/designer/
%{_qt6_examplesdir}/plugins/
%endif
%{_qt6_libdir}/metatypes/qt6designer_relwithdebinfo_metatypes.json
%{_qt6_libdir}/metatypes/qt6designercomponentsprivate_relwithdebinfo_metatypes.json

#------------------------------------------------------------------------------

%package -n %{libqtuitools}
Summary:        Qt%{qtmajor} UiTools Library
Group:          System/Libraries
Provides:       qt6uitoolslib = %{version}

%description -n %{libqtuitools}
Qt%{qtmajor} UiTools Component Library.

%files -n %{libqtuitools}
%{_qt6_libdir}/libQt6UiTools.so.%{qtmajor}{,.*}

#------------------------------------------------------------------------------

%package -n %{libqtuitools_d}
Summary:        Devel files needed to build apps based on QtUiTools
Group:          Development/KDE and Qt
Requires:       %{libqtuitools} = %{version}
Requires:       qttools6-designer = %{version}
Provides:       libqtuitools6-devel = %{version}
Provides:       libqt6uitools-devel = %{version}
Provides:       qtuitools6-devel = %{version}
Provides:       qt6uitools-devel = %{version}

Provides:       libqtuitools6-private-devel = %{version}
Provides:       libqt6uitools-private-devel = %{version}
Provides:       qtuitools6-private-devel = %{version}
Provides:       qt6uitools-private-devel = %{version}

%description -n %{libqtuitools_d}
Devel files needed to build apps based on QtUiTools.

%files -n %{libqtuitools_d}
%{_qt6_libdir}/libQt6UiTools.prl
%{_qt6_libdir}/libQt6UiTools.so
%{_qt6_includedir}/QtUiTools/
%{_qt6_includedir}/QtUiPlugin/
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_uitools.pri
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_uiplugin.pri
%{_qt6_libdir}/cmake/Qt6UiTools/
%{_qt6_libdir}/cmake/Qt6UiPlugin/
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_uitools_private.pri
%{_qt6_datadir}/modules/UiTools.json
%{_qt6_datadir}/modules/UiPlugin.json
%if ! 0%{?bootstrap}
%{_qt6_examplesdir}/uitools/
%endif

#------------------------------------------------------------------------------

%package -n %{libqttools_d}
Summary:        Devel files needed to build apps based on QtTools
Group:          Development/KDE and Qt
Requires:       %{libqthelp_d} = %{version}
Requires:       %{libqtdesigner_d} = %{version}
Requires:       %{libqtuitools_d} = %{version}
Provides:       libqttools6-devel = %{version}
Provides:       libqt6tools-devel = %{version}
Provides:       qttools6-devel = %{version}
Provides:       qt6tools-devel = %{version}

Provides:       libqttools6-private-devel = %{version}
Provides:       libqt6tools-private-devel = %{version}
Provides:       qttools6-private-devel = %{version}
Provides:       qt6tools-private-devel = %{version}

%description -n %{libqttools_d}
Devel files needed to build apps based on QtTools.

%files -n %{libqttools_d}
%{_qt6_includedir}/QtTools/
%{_qt6_libdir}/cmake/Qt6Tools/
%{_qt6_libdir}/cmake/Qt6ToolsTools/
%{_qt6_datadir}/modules/Tools.json
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_tools_private.pri
#
%{_qt6_libdir}/cmake/Qt6BuildInternals/StandaloneTests/QtToolsTestsConfig.cmake
%{_qt6_libdir}/metatypes/qt6uitools_relwithdebinfo_metatypes.json

#------------------------------------------------------------------------------

%prep
%setup -q -n qttools-everywhere-src-%{qtversion}
%autopatch -p1

%build
%cmake_qt6 -DQT_BUILD_EXAMPLES:BOOL=%{!?bootstrap:ON}%{?bootstrap:OFF}

%cmake_build

%if %{build_docs}
%__make docs
%endif

%install
%cmake_install

%if %{build_docs}
%make_install install_docs INSTALL_ROOT=%{buildroot}
%endif

mkdir -p %{buildroot}%{_datadir}/applications
install -m 644 %{SOURCE1} %{buildroot}%{_datadir}/applications
install -m 644 %{SOURCE2} %{buildroot}%{_datadir}/applications
install -m 644 %{SOURCE3} %{buildroot}%{_datadir}/applications
sed -i -e 's#@_qt6_bindir@#%{_qt6_bindir}#' %{buildroot}%{_datadir}/applications/*.desktop

# hardlink files to {_bindir}, add -qt6 postfix to not conflict
mkdir %{buildroot}%{_bindir}
pushd %{buildroot}%{_qt6_bindir}
for i in * ; do
  case "${i}" in
   assistant|designer|lconvert|linguist|lrelease|lupdate|pixeltool|qcollectiongenerator| \
   qdbus|qdbusviewer|qhelpconverter|qhelpgenerator|qtplugininfo|qtattributionsscanner| \
   qtpaths|qdistancefieldgenerator|qdoc|qtdiag)
      ln -v  ${i} %{buildroot}%{_bindir}/${i}-qt6
      ln -sv ${i} ${i}-qt6
      ;;
    *)
      ln -v  ${i} %{buildroot}%{_bindir}/${i}
      ;;
  esac
done
popd

pushd %{buildroot}%{_libdir}
for i in * ; do
  case "${i}" in
   lprodump|lrelease-pro|lupdate-pro)
      ln -v  ${i} %{buildroot}%{_libdir}/${i}-qt6
      ;;
  esac
done
popd

# Fix all buildroot paths
find %{buildroot}%{_qt6_libdir} -type f -name '*prl' -exec perl -pi -e "s, -L%{_builddir}/\S+,,g" {} \;
find %{buildroot}%{_qt6_libdir} -type f -name '*prl' -exec sed -i -e "/^QMAKE_PRL_BUILD_DIR/d" {} \;
find %{buildroot}%{_qt6_libdir} -type f -name '*la' -print -exec perl -pi -e "s, -L%{_builddir}/?\S+,,g" {} \;


# .la and .a files, die, die, die.
find %{buildroot} -name '*.la' -delete


%changelog
* Sun Aug 28 2022 neoclust <neoclust> 6.3.1-1.mga8
+ Revision: 1881465
- Add qt6-rpm-macros package into backport

* Sun Aug 28 2022 neoclust <neoclust> 6.3.1-1.mga9
+ Revision: 1881401
- New version 6.3.1

* Sun Jul 03 2022 neoclust <neoclust> 6.3.0-1.mga9
+ Revision: 1867209
- New version 6.3.0

* Sun Apr 03 2022 umeabot <umeabot> 6.2.3-2.mga9
+ Revision: 1842765
- Mageia 9 Mass Rebuild

* Sun Feb 20 2022 neoclust <neoclust> 6.2.3-1.mga9
+ Revision: 1781925
- New version 6.2.3

* Sun Nov 14 2021 neoclust <neoclust> 6.2.1-1.mga9
+ Revision: 1756256
- New version 6.2.1

* Sat Nov 13 2021 neoclust <neoclust> 6.2.0-1.mga9
+ Revision: 1756207
- Remove qtpaths package, now in qtbase6
- New version 6.2.0

* Sat May 15 2021 daviddavid <daviddavid> 6.1.0-3.mga9
+ Revision: 1723741
- add more BRs on non bootstrap build

* Sat May 15 2021 daviddavid <daviddavid> 6.1.0-2.mga9
+ Revision: 1723707
- non bootstrap build

* Tue May 11 2021 daviddavid <daviddavid> 6.1.0-1.mga9
+ Revision: 1722496
- initial package qttools6

